require('lang.load')

import('application.Interface')
import('model.events.CursorStackChanged')
import('model.events.InventoryChanged')
import('model.events.gui.GuiClickEvent')
import('model.events.gui.GuiElementChangedEvent')
import('model.events.gui.GuiLocationChangedEvent')
import('model.Cursor')
import('model.Inventory')

---@param eventData EventData
script.on_event("interface-mod_create-toolbar", function(eventData)
    --Interface:getInstanceFor(eventData.player_index):deleteAll()
    Interface:getInstanceFor(eventData.player_index):createToolbar()
end)

---@param eventData EventData
script.on_event(defines.events.on_gui_click, function(eventData)
    Interface:getInstanceFor(eventData.player_index):handleGuiClick(GuiClickEvent:new(eventData))
end)

---@param eventData EventData
script.on_event(defines.events.on_gui_elem_changed, function(eventData)
    Interface:getInstanceFor(eventData.player_index):handleGuiChange(GuiElementChangedEvent:new(eventData))
end)

---@param eventData EventData
script.on_event(defines.events.on_gui_location_changed, function(eventData)
    Interface:getInstanceFor(eventData.player_index):handleGuiChange(GuiLocationChangedEvent:new(eventData))
end)

---@param eventData EventData
script.on_event(defines.events.on_player_cursor_stack_changed, function(eventData)
    Interface:getInstanceFor(eventData.player_index):handle(CursorStackChanged:new(eventData))
end)

---@param eventData EventData
script.on_event(defines.events.on_player_main_inventory_changed, function(eventData)
    Interface:getInstanceFor(eventData.player_index):handle(InventoryChanged:new())
end)

---@param eventData EventData
script.on_event(defines.events.on_player_trash_inventory_changed, function(eventData)
    Interface:getInstanceFor(eventData.player_index):handle(InventoryChanged:new())
end)

-- seems that defines.events.on_player_changed_surface is triggered before new inventory is available
---@param eventData EventData
script.on_event(defines.events.on_player_toggled_map_editor, function(eventData)
    Interface:getInstanceFor(eventData.player_index):handle(InventoryChanged:new())
end)

remote.add_interface("interface-mod", {
    updateCount = function(player_index)
        for _ = 0, 0 do
            Interface:getInstanceFor(player_index):handle(InventoryChanged:new())
        end
    end
})
