import('model.GuiEvent')

---@class GuiClickEvent : GuiEvent
GuiClickEvent = GuiEvent:extendAs("model.gui.GuiClickEvent")

---@param eventData EventData
function GuiClickEvent:new(eventData)
    return GuiClickEvent:super(GuiEvent:new(eventData))
end

---@public
---@return boolean
function GuiClickEvent:isLeftClick()
    return self:data().button ==  defines.mouse_button_type.left
end

---@public
---@return boolean
function GuiClickEvent:isMiddleClick()
    return self:data().button ==  defines.mouse_button_type.middle
end

---@public
---@return boolean
function GuiClickEvent:isRightClick()
    return self:data().button ==  defines.mouse_button_type.right
end

---@public
---@return boolean
function GuiClickEvent:withModifier()
    return self:withCtrl() or self:withAlt() or self:withShift()
end

---@public
---@return boolean
function GuiClickEvent:withCtrl()
    return self:data().control
end

---@public
---@return boolean
function GuiClickEvent:withAlt()
    return self:data().alt
end

---@public
---@return boolean
function GuiClickEvent:withShift()
    return self:data().shift
end
