import('model.Component')
import('model.toolbar.content.sections.section.Section')

---@class Sections : Component
Sections = Slot:extendAs("model.toolbar.content.sections.Sections")

function Sections:create(parent)
    local this = Component.create(self, parent,  {
        type = "flow",
        direction = "vertical",
        style = "toolbar_content_sections" })
    this:addSection()
    return this
end

---@public
---@return Sections
---@param root LuaGuiElement
function Sections:new(parent, root)
    local instance = Sections:super(Component:new(parent, root))
    instance:loadChildren()
    return instance
end

function Sections:childrenClasses()
    return { Section }
end

---@public
function Sections:addSection()
    Section:create(self)
end

---@public
---@return number
function Sections:count()
    return #self:root().children
end

---@public
---@return Section[]
function Sections:list()
    return self:childrenOfType(Section)
end
