import('lang.Object')
import('model.events.gui.GuiClickEvent')
import('model.events.gui.GuiElementChangedEvent')
import('model.toolbar.content.sections.section.content.table.Slot')
import('model.toolbar.content.sections.section.content.table.slots.Item')
import('model.toolbar.content.sections.section.content.table.slots.Tool')

---@class Empty : Slot
Empty = Slot:extendAs("model.toolbar.content.sections.section.content.table.slots.Empty")

function Empty:create(parent)
    return Component.create(self, parent, {
        type = "choose-elem-button",
        elem_type = "item",
        style = "toolbar_content_sections_section_content_table_row_slot",
        mouse_button_filter = { "left", "middle" } })
end

function Empty:new(parent, root)
    return Empty:super(Slot:new(parent, root))
end

function Empty:handleGuiClick(guiClickEvent)
    local cursor = self:cursor()
    if guiClickEvent:isLeftClick() then
        if cursor:holdsSomething() then
            if cursor:holdsItem() then
                self:setItem(cursor:itemName())
            elseif cursor:holdsTool() then
                self:setTool(cursor:itemName())
            end
            self:handleItemDrag()
        end
    end
end

function Empty:handleGuiChange(guiChangedEvent)
    local cursor = self:cursor()
    if cursor:holdsBlueprint() or cursor:holdsPlanner() then
        self:root().elem_value = nil
    elseif cursor:holdsItem() then
        self:setItem(cursor:itemName())
        self:handleItemDrag()
    elseif self:isOccupied() then
        self:setItem(self:itemName())
    end
end

function Empty:handleItemDrag()
    local cursor = self:cursor()
    if self:wasDragged(self:cursor():itemName()) then
        self:drag()
    end
    cursor:clear()
    self:forgetPick()
end

function Empty:itemName()
    return self:root().elem_value
end
