import('model.events.gui.GuiClickEvent')
import('model.toolbar.header.ToolbarHeaderButton')

---@class CollapseToolbar : ToolbarHeaderButton
CollapseToolbar = ToolbarHeaderButton:extendAs("model.toolbar.header.Collapse")

function CollapseToolbar:create(parent)
    return Component.create(self, parent, {
        type = "sprite-button",
        sprite = "interface-mod_collapse",
        style = "toolbar_header_collapse" })
end

function CollapseToolbar:new(parent, root)
    return CollapseToolbar:super(ToolbarHeaderButton:new(parent, root))
end

function CollapseToolbar:handleGuiClick(guiClickEvent)
    if guiClickEvent:isLeftClick() then
        self:toolbar():collapse()
        local expand = ExpandToolbar:create(self:parent())
        if self:isLocked() then
            expand:lock()
        end
        self:replaceWith(expand)
    end
end
