import('model.events.gui.GuiClickEvent')
import('model.toolbar.header.ToolbarHeaderButton')
import('model.toolbar.header.CollapseToolbar')

---@class ExpandToolbar : ToolbarHeaderButton
ExpandToolbar = ToolbarHeaderButton:extendAs("model.toolbar.header.Expand")

function ExpandToolbar:create(parent)
    return Component.create(self, parent, {
        type = "sprite-button",
        sprite = "interface-mod_expand",
        style = "toolbar_header_expand" })
end

function ExpandToolbar:new(parent, root)
    return ExpandToolbar:super(ToolbarHeaderButton:new(parent, root))
end

function ExpandToolbar:handleGuiClick(guiClickEvent)
    if guiClickEvent:isLeftClick() then
        self:toolbar():expand()
        local collapse = CollapseToolbar:create(self:parent())
        if self:isLocked() then collapse:lock() end
        self:replaceWith(collapse)
    end
end
