import('model.events.gui.GuiClickEvent')
import('model.toolbar.header.ToolbarHeaderButton')
import('model.toolbar.header.Unlock')

---@class Lock : ToolbarHeaderButton
Lock = ToolbarHeaderButton:extendAs("model.toolbar.header.Lock")

function Lock:create(parent)
    return Component.create(self, parent, {
        type = "sprite-button",
        sprite = "interface-mod_padlock-open",
        style = "toolbar_header_lock" })
end

function Lock:new(parent, root)
    return Lock:super(ToolbarHeaderButton:new(parent, root))
end

function Lock:handleGuiClick(guiClickEvent)
    if guiClickEvent:isLeftClick() then
        self:toolbar():lock()
    end
end

function Lock:lock()
    self:replaceWith(Unlock:create(self:parent()))
end
